#!/usr/bin/env python
# -*- coding: utf-8 -*-
 
from setuptools import setup, find_packages
import codecs
import os.path

import pyant

here = os.path.abspath(os.path.dirname(__file__))

def read(*parts):
    return codecs.open(os.path.join(here, *parts), 'r').read()

long_description = read('PROJECT.txt')
lst = [i for i in pyant.ANTCLASS.keys()]
lst.sort()
for i in lst:
    long_description = long_description + '\n%s\n%s\n' % (i, '-'*len(i))
    for l in pyant.ANTCLASS[i].__doc__.split('\n'):
        long_description = long_description + l.lstrip() + '\n' 

setup(
 
    name='pyant',
    version=pyant.__version__,
    packages=find_packages(),
    author="Frederic Aoustin",
    author_email="mydevpython@gmail.com",
    description="ant by python",
    long_description=long_description,
    install_requires= ['mytools>=0.0.3',],
    include_package_data=False,
 
    url='http://mypage.com',
 
    classifiers=[
        "Programming Language :: Python",
        "Development Status :: 3 - Alpha",
        "License :: OSI Approved",
        "Natural Language :: French",
        "Operating System :: OS Independent",
        "Environment :: Console", 
        "Programming Language :: Python :: 2.7",
        "Programming Language :: Python :: 3",
        "Programming Language :: Python :: 3.0",
        "Programming Language :: Python :: 3.1",
        "Programming Language :: Python :: 3.2",
        "Programming Language :: Python :: 3.3",
        "Programming Language :: Python :: 3.4",
        "Topic :: Communications",
        "Topic :: Terminals",
    ],
 
 
    entry_points = {
        'console_scripts': [
            'pyant = pyant.parser:load',
        ],
    },
 
)
